commit 8a2fbbe387f06284d7427240be9a4b8c70b2212e
Author: freddy77 <freddy77>
Date:   Mon Jul 5 14:22:19 2010 +0000

    support SQL_NO_TOTAL from SQLGetData

diff --git a/ChangeLog b/ChangeLog
index 0139514..fc63bf8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Jul  5 16:22:06 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/blob1.c: support SQL_NO_TOTAL from SQLGetData
+
 Mon Jul  5 11:19:56 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/array.c src/odbc/unittests/array_out.c:
 	* src/odbc/unittests/attributes.c src/odbc/unittests/base.c:
@@ -2636,4 +2639,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3060 2010/07/05 09:20:32 freddy77 Exp $
+$Id: ChangeLog,v 1.3061 2010/07/05 14:22:19 freddy77 Exp $
diff --git a/src/odbc/unittests/blob1.c b/src/odbc/unittests/blob1.c
index e2c5de7..338167b 100755
--- a/src/odbc/unittests/blob1.c
+++ b/src/odbc/unittests/blob1.c
@@ -5,7 +5,7 @@
 #include <ctype.h>
 #include <assert.h>
 
-static char software_version[] = "$Id: blob1.c,v 1.22 2010/07/05 09:20:32 freddy77 Exp $";
+static char software_version[] = "$Id: blob1.c,v 1.23 2010/07/05 14:22:19 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define NBYTES 10000
@@ -115,8 +115,10 @@ readBlob(test_info *t)
 		total += len;
 	}
 	printf(">>   total bytes read = %d \n", (int) total);
-	if (total != 10000)
+	if (total != 10000) {
+		fprintf(stderr, "Wrong buffer length, expected 20000\n");
 		failed = 1;
+	}
 }
 
 static void
@@ -143,11 +145,15 @@ readBlobAsChar(test_info *t, int step, int wide)
 	while (rc == SQL_SUCCESS_WITH_INFO) {
 		i++;
 		rc = CHKGetData(t->num, type, (SQLPOINTER) buf, (SQLINTEGER) bufsize, &len, "SINo");
+		if (rc == SQL_SUCCESS_WITH_INFO && len == SQL_NO_TOTAL) {
+			len = bufsize - char_len;
+			rc = SQL_SUCCESS;
+		}
 		if (rc == SQL_NO_DATA || len <= 0)
 			break;
 		rc = CHKGetData(t->num, type, (SQLPOINTER) buf, 0, &len2, "SINo");
 //		printf("out_len %u bufsize %u len2 %u\n", (unsigned) len, (unsigned) bufsize, (unsigned) len2);
-		if (rc == SQL_SUCCESS_WITH_INFO)
+		if (rc == SQL_SUCCESS_WITH_INFO && len2 != SQL_NO_TOTAL)
 			len = len - len2;
 #if 0
 		if (len > (SQLLEN) (bufsize - char_len))
@@ -170,8 +176,10 @@ readBlobAsChar(test_info *t, int step, int wide)
 		total += len;
 	}
 	printf(">>   total bytes read = %d \n", (int) total);
-	if (total != 20000)
+	if (total != 20000) {
+		fprintf(stderr, "Wrong buffer length, expected 20000\n");
 		failed = 1;
+	}
 }
 
 static void

